/*
 * JPA entity template
 *
 *
 * Takatuka - Template fuer JPA2 Entitaeten (inklusive Bean Validation)
 *
 * Moeglichkeiten und Einschraenkungen:
 * - Beziehungen werden abgebildet
 * -- es gibt keine 1:1 Beziehungen
 * -- N:M Beziehungen sind immer bidirektional
 * - Vererbung wird nicht unterstuetzt
 * - Support für CustomData
 */
package de.ivu.elect.business.person.entity;

@javax.persistence.NamedQueries(
 {



       @javax.persistence.NamedQuery(
     name="TAG.UK",
     query="SELECT o FROM Tag o WHERE "

                         + "o"
                +".nameNormalisiert"
              +" = ?1"

             +" AND "         + "o"
                +".mandant"
                +".nummer"
              +" = ?2"

     ,
   hints = {
              @javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
             @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
   }


   )
   
     ,   @javax.persistence.NamedQuery(
     name="TAG.All",
     query="SELECT o FROM Tag o",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "false"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="TAG.Mandant",
     query="SELECT o FROM Tag o WHERE o.mandant = ?1",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="TAG.NameNormalisiertMandant",
     query="SELECT o FROM Tag o WHERE o.nameNormalisiert = ?1 AND o.mandant = ?2",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
     }
)
@javax.enterprise.inject.Vetoed
@javax.persistence.Entity
@javax.persistence.Table(name = "TAG")
// @javax.persistence.IdClass(TagPK.class)
    @javax.persistence.EntityListeners(de.ivu.elect.jee.protokollierung.ProtokollEntityListener.class)
    @javax.persistence.Cacheable

public
 class Tag
extends AbstractTag
  {

  private static final long serialVersionUID = 0L;


  /**
   * default constructor
   */
  public Tag() {
    super();
  }

    /**
     * @param original
     *
     * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
     *             als Deprecated.
     */
    @Deprecated
    public Tag(Tag original){
      original.copyEntity(this);
    }

  /**
   * PRIMARY KEY
   */
  @javax.persistence.Id
  @javax.persistence.Column(name = "tag_id")
    @javax.persistence.GeneratedValue(strategy = javax.persistence.GenerationType.TABLE, generator = "Tag")
    @javax.persistence.TableGenerator(name = "Tag", table = "SEQUENCES", pkColumnName = "sequence_name", pkColumnValue = "Tag", valueColumnName = "next_val", allocationSize = 1000, initialValue = 0)
    protected java.lang.Long id;

  @Override
  public java.lang.Long getId() {
    return id;
  }

  public void setId(java.lang.Long id) {
    this.id = id;
  }

  @javax.persistence.Transient
  private transient TagPK pkCache;

  @Override
  public TagPK getPk() {
    if (pkCache==null || pkCache.getId() != id ) {
      pkCache = new TagPK(getId());
    }

    return pkCache;
  }

  public static <E extends Tag> java.util.Map<TagPK, E> mappeNachPk(java.util.Collection<E> entities){
    java.util.Map<TagPK, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getPk(), entity);
    }

    return result;
  }

  public static <E extends Tag> java.util.Map<Long, E> mappeNachId(java.util.Collection<E> entities){
    java.util.Map<Long, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getId(), entity);
    }

    return result;
  }



  /**
   * Indikator, ob sich ein Attribut oder eine UNIDIREKTIONALE n:1-Beziehungen geaendert hat
   */
  @javax.persistence.Transient
  protected boolean attributeChanged = false;

  public void setAttributeChanged() {
    attributeChanged = true;
  }

  public boolean isAttributeChanged() {
    return attributeChanged;
  }

  /**
   * Hilfsvariable fuer das Aktualisieren von Beziehungen
   */
  @javax.persistence.Transient
  protected boolean updateRelationship = false;



  public void resetAttributeChanged() {
        hasChangedBemerkung = false;
          hasChangedName = false;
          hasChangedNameNormalisiert = false;
          hasChangedNeuerName = false;
          hasChangedStatus = false;
  
      hasChangedMandant = false;
  


    attributeChanged = false;
  }


  /**
   * ATTRIBUTE
   */

    
  @javax.persistence.Column(name = "BEMERKUNG", nullable = TagConstants.BEMERKUNG_NULLABLE, length=TagConstants.BEMERKUNG_MAX_LENGTH)
        
  protected java.lang.String bemerkung =  null;

  @javax.persistence.Transient
  protected boolean hasChangedBemerkung = false;

  public boolean hasChangedBemerkung(){
    return hasChangedBemerkung;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertBemerkung = false;
     @javax.persistence.Transient
     private transient java.lang.String wertNachLadenBemerkung;
  
  /**
   * 
   *
   * getter for TAG.BEMERKUNG
   */
  @javax.annotation.Nullable   @Override   public  java.lang.String getBemerkung() {
        return bemerkung;
      }

  /**
   * 
   *
   * setter for TAG.BEMERKUNG
   *
   * @param bemerkung
   */
  @Override   public void setBemerkung(@javax.annotation.Nullable  java.lang.String bemerkung) {

       resetTkCache();
                  
                          java.lang.String bemerkungInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(bemerkung, TagConstants.BEMERKUNG_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.bemerkung
      , bemerkungInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedBemerkung |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("bemerkung");
      }


             if (!isSeitLadenVeraendertBemerkung) {
          isSeitLadenVeraendertBemerkung = thisAttributChanged;
         if (isSeitLadenVeraendertBemerkung){
           wertNachLadenBemerkung=this.bemerkung;
         }
       }
      

       this.bemerkung = bemerkungInternal;

         }

        
      @javax.persistence.Column(name = "NAME", nullable = TagConstants.NAME_NULLABLE, length=TagConstants.NAME_MAX_LENGTH)
        
  protected java.lang.String name =  null;

  @javax.persistence.Transient
  protected boolean hasChangedName = false;

  public boolean hasChangedName(){
    return hasChangedName;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertName = false;
     @javax.persistence.Transient
     private transient java.lang.String wertNachLadenName;
  
  /**
   * 
   *
   * getter for TAG.NAME
   */
    @Override   public  java.lang.String getName() {
        return name;
      }

  /**
   * 
   *
   * setter for TAG.NAME
   *
   * @param name
   */
  @Override   public void setName( java.lang.String name) {

       resetTkCache();
                  
                          java.lang.String nameInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(name, TagConstants.NAME_MAX_LENGTH, getId(), getClass());
                  
                java.lang.String alterWert = getName();
         nameInternal = preProcessName(nameInternal);
         preSetName(alterWert, nameInternal);
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.name
      , nameInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedName |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("name");
      }


             if (!isSeitLadenVeraendertName) {
          isSeitLadenVeraendertName = thisAttributChanged;
         if (isSeitLadenVeraendertName){
           wertNachLadenName=this.name;
         }
       }
      

       this.name = nameInternal;

                postSetName(alterWert, nameInternal);
         }

  
    @Override
    protected java.lang.String preProcessName(java.lang.String neuerWert) {
      return super.preProcessName(neuerWert);
    }

    @Override
    protected void preSetName(java.lang.String alterWert, java.lang.String neuerWert) {
      super.preSetName(alterWert, neuerWert);
    }

    @Override
    protected void postSetName(java.lang.String alterWert, java.lang.String neuerWert) {
      super.postSetName(alterWert, neuerWert);
    }
        
      @javax.persistence.Column(name = "NAME_NORM", nullable = TagConstants.NAME_NORM_NULLABLE, length=TagConstants.NAME_NORM_MAX_LENGTH)
        
  protected java.lang.String nameNormalisiert =  null;

  @javax.persistence.Transient
  protected boolean hasChangedNameNormalisiert = false;

  public boolean hasChangedNameNormalisiert(){
    return hasChangedNameNormalisiert;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertNameNormalisiert = false;
     @javax.persistence.Transient
     private transient java.lang.String wertNachLadenNameNormalisiert;
  
  /**
   * 
   *
   * getter for TAG.NAME_NORM
   */
    @Override   public  java.lang.String getNameNormalisiert() {
        return nameNormalisiert;
      }

  /**
   * 
   *
   * setter for TAG.NAME_NORM
   *
   * @param nameNormalisiert
   */
  @Override   public void setNameNormalisiert( java.lang.String nameNormalisiert) {

       resetTkCache();
                  
                          java.lang.String nameNormalisiertInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(nameNormalisiert, TagConstants.NAME_NORM_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.nameNormalisiert
      , nameNormalisiertInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedNameNormalisiert |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("nameNormalisiert");
      }


             if (!isSeitLadenVeraendertNameNormalisiert) {
          isSeitLadenVeraendertNameNormalisiert = thisAttributChanged;
         if (isSeitLadenVeraendertNameNormalisiert){
           wertNachLadenNameNormalisiert=this.nameNormalisiert;
         }
       }
      

       this.nameNormalisiert = nameNormalisiertInternal;

         }

        
  @javax.persistence.Column(name = "NEUER_NAME", nullable = TagConstants.NEUER_NAME_NULLABLE, length=TagConstants.NEUER_NAME_MAX_LENGTH)
        
  protected java.lang.String neuerName =  null;

  @javax.persistence.Transient
  protected boolean hasChangedNeuerName = false;

  public boolean hasChangedNeuerName(){
    return hasChangedNeuerName;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertNeuerName = false;
     @javax.persistence.Transient
     private transient java.lang.String wertNachLadenNeuerName;
  
  /**
   * 
   *
   * getter for TAG.NEUER_NAME
   */
  @javax.annotation.Nullable   @Override   public  java.lang.String getNeuerName() {
        return neuerName;
      }

  /**
   * 
   *
   * setter for TAG.NEUER_NAME
   *
   * @param neuerName
   */
  @Override   public void setNeuerName(@javax.annotation.Nullable  java.lang.String neuerName) {

       resetTkCache();
                  
                          java.lang.String neuerNameInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(neuerName, TagConstants.NEUER_NAME_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.neuerName
      , neuerNameInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedNeuerName |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("neuerName");
      }


             if (!isSeitLadenVeraendertNeuerName) {
          isSeitLadenVeraendertNeuerName = thisAttributChanged;
         if (isSeitLadenVeraendertNeuerName){
           wertNachLadenNeuerName=this.neuerName;
         }
       }
      

       this.neuerName = neuerNameInternal;

         }

        
    @javax.persistence.Enumerated(javax.persistence.EnumType.STRING)
      @javax.persistence.Column(name = "STATUS", nullable = TagConstants.STATUS_NULLABLE)
    
  protected de.ivu.elect.business.person.entity.TagStatus status =  de.ivu.elect.business.person.entity.TagStatus.AKTIV;

  @javax.persistence.Transient
  protected boolean hasChangedStatus = false;

  public boolean hasChangedStatus(){
    return hasChangedStatus;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertStatus = false;
     @javax.persistence.Transient
     private transient de.ivu.elect.business.person.entity.TagStatus wertNachLadenStatus;
  
  /**
   * 
   *
   * getter for TAG.STATUS
   */
    @Override   public  de.ivu.elect.business.person.entity.TagStatus getStatus() {
        return status;
      }

  /**
   * 
   *
   * setter for TAG.STATUS
   *
   * @param status
   */
  @Override   public void setStatus( de.ivu.elect.business.person.entity.TagStatus status) {

       resetTkCache();
                  de.ivu.elect.business.person.entity.TagStatus statusInternal = status;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.status
      , statusInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedStatus |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("status");
      }


             if (!isSeitLadenVeraendertStatus) {
          isSeitLadenVeraendertStatus = thisAttributChanged;
         if (isSeitLadenVeraendertStatus){
           wertNachLadenStatus=this.status;
         }
       }
      

       this.status = statusInternal;

         }

    
/**
 * Beziehungen N:1 unidirektional
 */
  /**
   * Beziehung (unidirektional) zu Mandant
   */
  @javax.persistence.ManyToOne(fetch =  javax.persistence.FetchType.LAZY , optional=false, cascade = {javax.persistence.CascadeType.PERSIST})
  @javax.persistence.JoinColumns(@javax.persistence.JoinColumn(name = "MANDANT_ID", referencedColumnName="MANDANT_ID"))
  protected de.ivu.elect.business.mandant.entity.Mandant mandant;

  /**
   * 
   */
  @Override
  public void setMandant( de.ivu.elect.business.mandant.entity.Mandant mandant){
    resetTkCache();
    
    boolean thisAttributChanged =
    !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.mandant
    , mandant);

    attributeChanged |= thisAttributChanged;

    hasChangedMandant |= thisAttributChanged;

    if (thisAttributChanged) {
    markDirty("mandant");
    }

    this.mandant = mandant;
      }

  /**
   * 
   */
    @Override
  public de.ivu.elect.business.mandant.entity.Mandant getMandant(){
    return this.mandant;
  }

  @javax.persistence.Transient
  protected boolean hasChangedMandant = false;

  public boolean hasChangedMandant(){
    return hasChangedMandant;
  }


/**
 * Beziehungen N:1 bidirektional
 */

  /**
   * Beziehungen 1:N unidirektional (nicht unterstuetzt)
   */

  /**
   * Beziehungen 1:N bidirektional
   */

  /**
   * Beziehungen N:M bidirektional nicht selbstreferenzierend
   */


  /**
   * Beziehungen N:M bidirektional selbstreferenzierend
   */
  

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("Tag:");
    sb.append(getId());
    sb.append(" (TK: ");
    try {
      sb.append(getTk());
    } catch (Exception e) {
      sb.append(e.getMessage());
    }
    sb.append(")");
    return sb.toString();
}



  /**
   * Kopiert alle Attribute (ausser PK und Version) und UNIDIREKTIONALE n:1-Beziehungen in uebergebene Entitaet.
   *
   * @param other
   *
   * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
   *             als Deprecated.
   */
  @Deprecated
  protected void copyEntity(Tag other){
                             other.bemerkung = this.bemerkung;
                                other.name = this.name;
                                other.nameNormalisiert = this.nameNormalisiert;
                                other.neuerName = this.neuerName;
                                other.status = this.status;
           
  other.setMandant(this.getMandant());
    if (this.transientContext != null && !this.transientContext.isEmpty()) {
      other.getTransientContext().putAll(this.transientContext);
    }
  }



    @Override
    public void copyEntityAttributesToOtherEntity(de.ivu.elect.jee.entity.Entity other) {
      if (other==null){
        return;
      }
      if (other.isInstanceOf(Tag.class)){
        copyEntityAttributesUsingSetter((Tag) other.castTo(Tag.class).getEntity());
      } else {
        throw new IllegalArgumentException("Keine Instanz von Tag: " + other);
      }
    }

  /**
  * Kopiert alle Attribute (ausser PK und Version)  in uebergebene Entitaet.
  *
  */
  public void copyEntityAttributesUsingSetter(Tag other){
               other.setBemerkung(this.bemerkung);
                  other.setName(this.name);
                  other.setNameNormalisiert(this.nameNormalisiert);
                  other.setNeuerName(this.neuerName);
                  other.setStatus(this.status);
           if (this.transientContext != null && !this.transientContext.isEmpty()) {
      other.getTransientContext().putAll(this.transientContext);
    }
  }


  /**
   * Kopiert alle veränderten Attribute (ausser PK, CustomData, wenn vorhanden und Version) in uebergebene Entitaet.
   *
   */
  public void copyChangedEntityAttributesUsingSetter(Tag other){
                       if (hasChangedBemerkung) {
        other.setBemerkung(this.bemerkung);
      }
                             if (hasChangedName) {
        other.setName(this.name);
      }
                             if (hasChangedNameNormalisiert) {
        other.setNameNormalisiert(this.nameNormalisiert);
      }
                             if (hasChangedNeuerName) {
        other.setNeuerName(this.neuerName);
      }
                             if (hasChangedStatus) {
        other.setStatus(this.status);
      }
             }





    @javax.persistence.Transient
    private transient TagTK tkCache;

    protected void resetTkCache() {
        tkCache = null;
    }

    public TagTK getTagTK(){
    if (tkCache==null) {
    tkCache = new TagTK(

getNameNormalisiert()


  );}
  return tkCache;
}
    @Override
    public de.ivu.elect.jee.entity.tk.EntityTK getTk() {
       return getTagTK();
    }

  @Override
  public TagUK getUk(){
    return getTagUK();
  }

  @Override
  public Class< ? > getEntityClass() {
    return Tag.class;
  }

public TagUK getTagUK(){

   return  new TagUK(

getNameNormalisiert()
,     getMandant()==null?null:getMandant().getMandantUK()


  );
}

  @javax.persistence.Transient
  private transient TagProperties properties;

  public TagProperties getProperties(){
    if (properties == null) {
      properties = new TagProperties(this);
    }
    return properties;
  }

  /**
   * @deprecated getProperties() verwenden.
   */
  @Deprecated
  public TagProperties getTagProperties(){
    return getProperties();
  }

  @Override
  public String getEntityTechnicalName() {
    return TagConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public boolean isAenderungenProtokollieren(){
    
    return true;
  }


    @Override
   public void setProtokollierteAttributeMitWerten(java.util.Map<String, de.ivu.elect.jee.protokollierung.AttributWertVorher> werteVorher) {
     
      if (werteVorher.containsKey(TagConstants.MESSAGE_KEY_BEMERKUNG_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(TagConstants.MESSAGE_KEY_BEMERKUNG_EINZAHL);

        bemerkung =
     vorher.getAttributTyp().getValueAsString(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(TagConstants.MESSAGE_KEY_NAME_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(TagConstants.MESSAGE_KEY_NAME_EINZAHL);

        name =
     vorher.getAttributTyp().getValueAsString(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(TagConstants.MESSAGE_KEY_NAME_NORM_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(TagConstants.MESSAGE_KEY_NAME_NORM_EINZAHL);

        nameNormalisiert =
     vorher.getAttributTyp().getValueAsString(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(TagConstants.MESSAGE_KEY_NEUER_NAME_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(TagConstants.MESSAGE_KEY_NEUER_NAME_EINZAHL);

        neuerName =
     vorher.getAttributTyp().getValueAsString(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(TagConstants.MESSAGE_KEY_STATUS_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(TagConstants.MESSAGE_KEY_STATUS_EINZAHL);

        status =
     (de.ivu.elect.business.person.entity.TagStatus) vorher.getAttributTyp().getValueAsEnum(vorher.getWertVorher());
          }

                }

  @Override
  public java.util.Map<String, de.ivu.elect.jee.protokollierung.VorherNachherWert> getProtokollierteAttributeMitWerten() {
    java.util.Map<String,de.ivu.elect.jee.protokollierung.VorherNachherWert> result;
        result = createEmptyProtokollierteAttributeMitWertenMap();
                        if (isSeitLadenVeraendertBemerkung) {
      result.put(TagConstants.MESSAGE_KEY_BEMERKUNG_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.STRING
                , wertNachLadenBemerkung , bemerkung));
    }
                            if (isSeitLadenVeraendertName) {
      result.put(TagConstants.MESSAGE_KEY_NAME_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.STRING
                , wertNachLadenName , name));
    }
                            if (isSeitLadenVeraendertNameNormalisiert) {
      result.put(TagConstants.MESSAGE_KEY_NAME_NORM_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.STRING
                , wertNachLadenNameNormalisiert , nameNormalisiert));
    }
                            if (isSeitLadenVeraendertNeuerName) {
      result.put(TagConstants.MESSAGE_KEY_NEUER_NAME_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.STRING
                , wertNachLadenNeuerName , neuerName));
    }
                            if (isSeitLadenVeraendertStatus) {
      result.put(TagConstants.MESSAGE_KEY_STATUS_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.ENUM
                , wertNachLadenStatus , status));
    }
                return result;
  }

  @Override
  public void resetProtokollierteAttribute() {
                      isSeitLadenVeraendertBemerkung = false;
      wertNachLadenBemerkung = null;
                          isSeitLadenVeraendertName = false;
      wertNachLadenName = null;
                          isSeitLadenVeraendertNameNormalisiert = false;
      wertNachLadenNameNormalisiert = null;
                          isSeitLadenVeraendertNeuerName = false;
      wertNachLadenNeuerName = null;
                          isSeitLadenVeraendertStatus = false;
      wertNachLadenStatus = null;
                   }

  @Override
  public  java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> getFachlichAbhaengigeEntitaeten(){
            java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> result = new java.util.ArrayList<>();
                    return result;
  }

        
            protected String getInitialDiscriminator() {
              return "TAG";
            }

            @Override
            public boolean isInstanceOf(Class<?> clazz) {
            return clazz.isInstance(this);
            }


            @Override
            public <E> de.ivu.elect.jee.entity.EntityContainer<E> castTo(Class<E> clazz) {
                return new de.ivu.elect.jee.entity.EntityContainer<>((E)this); // EntityContainer ist notwendig, da sonst von Hibernate die Entität wieder durch ihren Proxy ersetzt wird...
            }

  public boolean isPersistent() {
    return getId() != null;
  }


   private static final String BASE_CLASS_NAME = "Tag";
   @Override
   public String getBaseClassName() {
     return BASE_CLASS_NAME;
   }


    @Override
    public boolean equals(Object obj) {
    if (obj == null) {
    return false;
    }

    if (this==obj) {
    return true;
    }


    if (id != null) {
      try {
        return id.longValue() == ((de.ivu.elect.jee.entity.Entity) obj).getId().longValue() && BASE_CLASS_NAME.equals(((de.ivu.elect.jee.entity.Entity) obj).getBaseClassName());
      } catch (Exception ignored) {
        // do nothing
        return false;
      }
    }
   return super.equals(obj);
    }

    @Override
    public int hashCode() {

      if (id==null){
        return super.hashCode();
      }
      return id.hashCode();
    }


                            @javax.persistence.Transient
                private transient java.util.Set
            <String> dirtyProperties = null;

                protected void markDirty(String property) {
            
          }

          public java.util.Set
      <String> getDirtyProperties() {
          if (dirtyProperties==null){
          dirtyProperties = new java.util.HashSet<>();
          }
          return dirtyProperties;
          }

          public void clearDirtyProperties(){
          dirtyProperties = null;
          }
          public boolean isHibernateDirty() {
            return dirtyProperties!=null;
          }

      
                public void resetValidation() {
        
    validationResult = null;
        }

        @javax.persistence.Transient
        private transient java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validationResult;

                    public java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validateEntity() {
            if (validationResult==null) {
               validationResult  = new java.util.HashSet<>();
                                                                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(TagConstants.BEMERKUNG_MAX_LENGTH ,  bemerkung, this, TagConstants.MESSAGE_KEY_BEMERKUNG_EINZAHL, validationResult);
                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(name, this, TagConstants.MESSAGE_KEY_NAME_EINZAHL, validationResult);
                                                                          de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(TagConstants.NAME_MAX_LENGTH , 1 ,  name, this, TagConstants.MESSAGE_KEY_NAME_EINZAHL, validationResult);
                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(nameNormalisiert, this, TagConstants.MESSAGE_KEY_NAME_NORM_EINZAHL, validationResult);
                                                                          de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(TagConstants.NAME_NORM_MAX_LENGTH , 1 ,  nameNormalisiert, this, TagConstants.MESSAGE_KEY_NAME_NORM_EINZAHL, validationResult);
                                                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(TagConstants.NEUER_NAME_MAX_LENGTH ,  neuerName, this, TagConstants.MESSAGE_KEY_NEUER_NAME_EINZAHL, validationResult);
                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(status, this, TagConstants.MESSAGE_KEY_STATUS_EINZAHL, validationResult);
                                                                    }
             return validationResult;
        }

            
        @javax.persistence.Transient
        protected transient java.util.Map<String, Object> transientContext;

        public java.util.Map<String, Object> getTransientContext() {
          if (transientContext == null) {
             transientContext = new java.util.HashMap<>();
          }
        return transientContext;

        }

              }
